



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java Concurrency - 线程的基础操作</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java Concurrency - 线程的基础操作</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-02 12:41:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>创建线程</h2>
<p>在 Java 中，创建线程有两种方式：</p>
<ul><li>继承&nbsp;java.lang.Thread 类，重写 run 方法。</p>
<div>
<pre class="prettyprint linenums">public class MyJob extends Thread {

    @Override<br />
    public void run() {<br />
        System.out.println("Hello Thread");<br />
    }

    public static void main(String[] args) {<br />
        Thread thread = new MyJob();<br />
        thread.start();<br />
    }<br />
}</pre>
</div></li>
<li>实现&nbsp;java.lang.Runnable 接口，然后在创建&nbsp;Thread 实例时传入&nbsp;Runnable 参数。
<div>
<pre class="prettyprint linenums">public class MyJob implements Runnable {<br />
    @Override<br />
    public void run() {<br />
        System.out.println("Hello Thread");<br />
    }

    public static void main(String[] args) {<br />
        Thread thread = new Thread(new MyJob());<br />
        thread.start();<br />
    }<br />
}</pre>
</div></li></ul>
<h2>获取和设置线程信息</h2>
<p>java.lang.Thread 类中的几个信息字段帮助我们来识别一个线程、观察线程的状态或是控制线程的优先级：</p>
<ul><li>Id: 线程的 ID，每个线程拥有一个唯一的标识。</li>
<li>Name: 线程的名称。</li>
<li>Priority: 线程的优先级。优先级的范围是 1~10，值越大优先级越高。</li>
<li>State: 线程的状态。在 Java 中，线程有六种状态：NEW、RUNNABLE、BLOCKED、WAITING、TIMED_WAITING 和 TERMINATED。</li></ul>
<p>上述的属性 java.lang.Thread 类都提供 getter&nbsp;方法以获取线程的信息，其中 Id 和 State 是不可代码控制修改的，也不提供 setter 方法。</p>
<h2>获取当前正在运行的线程</h2>
<p>java.lang.Thread 类提供一个静态方法&nbsp;currentThread()，该方法返回当前正在运行的线程。</p>
<div>
<pre class="prettyprint linenums">public static void main(String[] args) {<br />
    System.out.println(Thread.currentThread().getName());    // main<br />
}</pre>
</div>
<h2>线程休眠</h2>
<p>Thread 类的 sleep() 方法接收一个 long 参数 milliseconds，使得当前正在运行的线程休眠&nbsp;milliseconds 毫秒。</p>
<p>TimeUnit 类同样提供提供 sleep() 方法支持线程休眠。它接收各种时间单位并将其转换成微秒。</p>
<div>
<pre class="prettyprint linenums">try {<br />
    TimeUnit.SECONDS.sleep(3);<br />
} catch (InterruptedException e) {<br />
    e.printStackTrace();<br />
}</pre>
</div>
<h2>线程中断</h2>
<p>有时候，我们需要在线程任务执行完毕前取消线程任务，例如当下载文件超时时取消下载任务。当&nbsp;interrupt() 方法被调用时，线程的中断状态被置为 true，但是线程并不会终止。可以利用&nbsp;isInterrupted 方法检测线程是否中断，并以此对线程进行控制。</p>
<div>
<pre class="prettyprint linenums">public static void main(String[] args) throws Exception {

    Thread task = new Thread(new Runnable() {<br />
        public void run() {<br />
            int num = 2;<br />
            while (!Thread.currentThread().isInterrupted()) {<br />
                if (Primes.isPrime(num)) {<br />
                    System.out.println(String.format("Number %d is Prime", num));<br />
                }<br />
                num++;<br />
            }<br />
        }<br />
    });

    task.start();<br />
    try {<br />
        TimeUnit.SECONDS.sleep(3);<br />
    } catch (InterruptedException e) {<br />
        e.printStackTrace();<br />
    }<br />
    task.interrupt();

}</pre>
</div>
<p>Thread 类还提供一个静态的&nbsp;interrupted() 方法来判断当前正在运行的线程是否中断。但是&nbsp;interrupted() 与&nbsp;isInterrupted() 有些差异：isInterrupted() 方法不会修改中断状态；而&nbsp;interrupted() 方法会将中断状态置为 true。</p>
<p>有时线程执行的任务十分复杂，使用异常控制会比条件控制更加可取。</p>
<div>
<pre class="prettyprint linenums">/**<br />
 * This class search for files with a name in a directory<br />
 */<br />
public class FileSearch implements Runnable {

    private String initPath;    // Initial path for the search<br />
    private String fileName;    // Name of the file we are searching for

    public FileSearch(String initPath, String fileName) {<br />
        this.initPath = initPath;<br />
        this.fileName = fileName;<br />
    }

    /**<br />
     * Main method of the class<br />
     */<br />
    @Override<br />
    public void run() {<br />
        File file = new File(initPath);<br />
        if (file.isDirectory()) {<br />
            try {<br />
                directoryProcess(file);<br />
            } catch (InterruptedException e) {<br />
                System.out.printf("%s: The search has been interrupted", Thread.currentThread().getName());<br />
                cleanResources();<br />
            }<br />
        }<br />
    }

    /**<br />
     * Method for cleaning the resources. In this case, is empty<br />
     */<br />
    private void cleanResources() {

    }

    /**<br />
     * Method that process a directory<br />
     *<br />
     * @param file<br />
     *            : Directory to process<br />
     * @throws InterruptedException<br />
     *            : If the thread is interrupted<br />
     */<br />
    private void directoryProcess(File file) throws InterruptedException {

        // Get the content of the directory<br />
        File list[] = file.listFiles();<br />
        if (list != null) {<br />
            for (int i = 0; i &lt; list.length; i++) {<br />
                if (list[i].isDirectory()) {<br />
                    // If is a directory, process it<br />
                    directoryProcess(list[i]);<br />
                } else {<br />
                    // If is a file, process it<br />
                    fileProcess(list[i]);<br />
                }<br />
            }<br />
        }<br />
        // Check the interruption<br />
        if (Thread.interrupted()) {<br />
            throw new InterruptedException();<br />
        }<br />
    }

    /**<br />
     * Method that process a File<br />
     *<br />
     * @param file<br />
     *            : File to process<br />
     * @throws InterruptedException<br />
     *             : If the thread is interrupted<br />
     */<br />
    private void fileProcess(File file) throws InterruptedException {<br />
        // Check the name<br />
        if (file.getName().equals(fileName)) {<br />
            System.out.printf("%s : %s\n", Thread.currentThread().getName() ,file.getAbsolutePath());<br />
        }

        // Check the interruption<br />
        if (Thread.interrupted()) {<br />
            throw new InterruptedException();<br />
        }<br />
    }

    /**<br />
     * Main method of the core. Search for the autoexect.bat file<br />
     * on the Windows root folder and its subfolders during ten seconds<br />
     * and then, interrupts the Thread<br />
     * @param args<br />
     */<br />
    public static void main(String[] args) {<br />
        // Creates the Runnable object and the Thread to run it<br />
        FileSearch searcher=new FileSearch("C:\\","CHAINLOG.log.2016092210");<br />
        Thread thread=new Thread(searcher);

        // Starts the Thread<br />
        thread.start();

        // Wait for ten seconds<br />
        try {<br />
            TimeUnit.SECONDS.sleep(10);<br />
        } catch (InterruptedException e) {<br />
            e.printStackTrace();<br />
        }

        // Interrupts the thread<br />
        thread.interrupt();<br />
    }<br />
}</pre>
</div>
<h2>join - 等待线程结束</h2>
<p>在某些情况下，需要等待某一线程执行完毕后当前的线程才能继续执行，例如等待某个资源初始化完毕后才能执行后续的操作。 Thread 类提供了 join() 方法来实现此功能。当在线程 thread1 中调用 thread2.join() 方法，那么 thread1&nbsp;线程将会挂起直至线程&nbsp;thread2 结束。</p>
<p>Example:</p>
<div>
<pre class="prettyprint linenums">public static void main(String[] args) throws Exception {

    Thread dataSourcesLoader = new Thread(new Runnable() {<br />
        public void run() {<br />
            System.out.printf("Begining data sources loading: %s\n",new Date());<br />
            try {<br />
                TimeUnit.SECONDS.sleep(4);<br />
            } catch (InterruptedException e) {<br />
                e.printStackTrace();<br />
            }<br />
            System.out.printf("Data sources loading has finished: %s\n",new Date());<br />
        }<br />
    });

    Thread networkConnectionsLoader = new Thread(new Runnable() {<br />
        @Override<br />
        public void run() {<br />
            System.out.printf("Begining network connections loading: %s\n",new Date());<br />
            try {<br />
                TimeUnit.SECONDS.sleep(6);<br />
            } catch (InterruptedException e) {<br />
                e.printStackTrace();<br />
            }<br />
            System.out.printf("Network connections loading has finished: %s\n",new Date());<br />
        }<br />
    });

    dataSourcesLoader.start();<br />
    networkConnectionsLoader.start();

    dataSourcesLoader.join();<br />
    networkConnectionsLoader.join();<br />
    System.out.printf("Main: Configuration has been loaded: %s\n",new Date());<br />
}</pre>
</div>
<p>jion 还有两个重载的方法：join (long milliseconds) 和&nbsp;join (long milliseconds, long nanos)。第一个方法接收一个 long 参数 milliseconds，如果在线程 thread1 中调用代码&nbsp;thread2.join(1000)，则 thread1 线程挂起直至当 thread2 线程执行完毕；或者当 1000 毫秒过去后，即使 thread2 仍未执行完毕，thread1 依然停止挂起，继续执行。</p>
<h2>守护进程</h2>
<p>在线程启动前调用&nbsp;setDaemon(true) 可以将线程设置为守护进程。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4953v3m8.html">如何用ZBrush快速绘制身体</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwrwwz9.html">布隆过滤器的概述及Python实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvxydj8.html">Android异步加载图像（含线程池，缓存方法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdxeg78.html">poj1704</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv4z71q.html">拉姆达表达式&lpar;Lambda Expressions&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoow1xq.html">cocos2d 简单的日常高仿酷跑游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpol239.html">typeof使用笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/950zngz8.html">201521123097《Java程序设计》第三周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1354jq.html">Matlab 编译EXE</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gewwx08.html">OS &plus; CentOS cmake</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkpg7z8.html">Git：七、标签（tag）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p6owj8.html">使用控制台对Redis执行增删改查命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllm1neq.html">L2-022 重排链表 （25 分&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyr1rxq.html">copy之深浅拷贝</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2xljoq.html">QT中全局变量的定义</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd4m5j9.html">Django电商项目---完成购物车页面day4</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdx3lz9.html">FFT ip core</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rnej39.html">bzoj千题计划307：bzoj5248&colon; &lbrack;2018多省省队联测&rsqb;一双木棋</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1mlo1q.html">HTTP协议的简单解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx250pj8.html">Angular 通过注入 &dollar;location 获取与修改当前页面URL</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mnkz3pq.html">Codeforces Round &num;349 &lpar;Div&period; 2&rpar;  D&period; World Tour &lpar;最短路&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjg6wy9.html">iOS－default&period;png启动图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x7rgg9.html">sqlserver表分区与调优与行列转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmv0x19.html">xmlBean学习二</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z46y69.html">PROCESS&lowbar;YIELD&lpar;&rpar;宏和C语言的switch语句&amp;lt&semi; contiki学习笔记之七&amp;gt&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mdy4kq.html">leetcode第一刷&lowbar;Count and Say</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k127k39.html">Oracle使用goldengate分别向Oracle和mysql双路的单向复制</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okym519.html">cocos2d-x如何优化内存的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z130239.html">python手记&lpar;50&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w3o5vq.html">ios开发&mdash;&mdash;实用技术篇Swift篇&amp;amp&semi;加速计和陀螺仪</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
